#ifndef Atoms_h
#define Atoms_h

#include "SimpleString.h"
#include "SimpleRBTree.h"

class Atoms {
public:
  Atoms();
  ~Atoms();
  Atoms(Atoms&);
  Atoms& operator=(Atoms&);

  void clear();
  // check whether already inserted
  int inserted(SimpleString&);
  int inserted(const char*);
  // lookup (and inserts if new) an atom in Atoms
  // returns the associated key
  int operator()(SimpleString&);
  int operator()(const char*);
  // given a key it returns its atom if defined
  // otherwise the emptystring
  SimpleString operator()(int);
  int size();
  
private:
  RBTree<SimpleString,int> rbt;
  SimpleString* a;
  int nextfree;
  int tablesize;
  enum {MINTABLESIZE = 4096};
  void ensure_tablelen(int);
};

#endif

