#ifndef Equations_h
#define Equations_h

// REM's Algo for maintaining equivalence classes
// adopted for handling equations between literals,
// i.e. if A = B then -A = -B.

#include "RArray.h"
#include "streaminclude.h"

class Equations {
public:
  Equations();
  Equations(const Equations& );
  Equations& operator=(const Equations& );
  ~Equations();

  void clear();
  int add(int left,int right);
  int operator()(int i); // get witness
  int equal(int i, int j);
  int operator[](int i);
  // iterate through all variables that are mapped
  int first(); 
  int last();
  int next();
  void Print(ostream& out = cout);
private:
  RArray<int> f;  
  int current;
};

inline int Equations::operator[](int i)
{
  return i > 0 ? f[i] : -f[-i];
}

#endif
