#ifndef Implications_h
#define Implications_h

#include "OrdInt.h"
#include "RArray.h"
#include "Equations.h"

// maintains a set of implications of the form 
// Li => {L_i1,...,L_ini}

class Implications {
public:
  Implications(int size = 128,Equations* aeq=0);
  ~Implications() {};

  void add(int literal,OrdInt& implied);
  void add(int literal,int implied);
  void del(int literal);
  OrdInt get_fixed(); // get all fixed literals 
  int calc_equations();
  int equations_empty();
  int pop_equation(int& left, int& right);
private:
  RArray<OrdInt> implications;
  Equations* eq;
  int eq_lit;

  void add_equation(int left,int right);
};

inline Implications::Implications(int size,Equations* aeq) : implications(-size,size)
{
  eq = aeq;
  eq_lit = 0;
}

#endif



