#include "LPBIRefs.h"

LPBIRefs::LPBIRefs(int from, int to)
{
  lpbiref.ensure(from,to);
}

LPBIRefs::LPBIRefs(const LPBIRefs& LR)
{
  lpbiref = LR.lpbiref;
}

LPBIRefs& LPBIRefs::operator=(const LPBIRefs& LR)
{
  lpbiref = LR.lpbiref;
  return *this;
}

LPBIRefs::~LPBIRefs()
{
}

int LPBIRefs::min()
{
  int i = lpbiref.lower();
  while ( (i <= lpbiref.upper()) && (lpbiref[i].empty()))
    i++;
  return i;
}

int LPBIRefs::max()
{
  int i = lpbiref.upper();
  while ( (i >= lpbiref.lower()) && (lpbiref[i].empty()))
    i--;
  return i;
}

int LPBIRefs::add(int iid, LPBIneq& lpbi)
{
  // ensure size of lpbiref
  while ((iid < lpbiref.lower()) || (iid > lpbiref.upper()))
    {
      int from = lpbiref.lower();
      int to = lpbiref.upper();
      int size = to-from+1;
      int middle = (from+to)/2;
      int newfrom = middle-size;
      int newto = middle+size;
      // double size, half in both directions
      lpbiref.ensure(newfrom,newto);
    }
  lpbiref[iid] = lpbi;
  return 0;
}

int LPBIRefs::del(int iid)
{
  lpbiref[iid].clear();
  return 0;
}

void LPBIRefs::clear()
{
  for (int i=lpbiref.lower(); i <= lpbiref.upper(); i++)
    lpbiref[i].clear();
}

int LPBIRefs::Print_One(int i, ostream& out, Atoms* atoms)
{
  if (!lpbiref[i].empty())
    {
      out << i << " : ";
      lpbiref[i].Print(out,atoms);
      out << "\n";
    }
  return 0;
}

int LPBIRefs::Print(ostream& out,Atoms* atoms)
{
  for (int i=lpbiref.lower();i <= lpbiref.upper();i++)
    Print_One(i,out,atoms);
  return 0;
}




