#ifndef LPBIRefs_h
#define LPBIRefs_h

#include "LPBIneq.h"
#include "RArray.h"
#include "Atoms.h"
extern "C" {
#include "stdlib.h"
}

class LPBIRefs {
public:
  LPBIRefs(int from = 0, int to=128);
  LPBIRefs(const LPBIRefs& );
  LPBIRefs& operator=(const LPBIRefs&);
  ~LPBIRefs();

  Products& operator[](int i) { return lpbiref[i].products; }
  LPBIneq& get_lpbi(int i) { return lpbiref[i]; }
  Product&  max_product(int i) { return lpbiref[i].products.head->next->product; }

  int upper() { return lpbiref.upper(); }
  int lower() { return lpbiref.lower(); }

  int min(); // smallest iid;
  int max(); // greatest iid;
  int empty(int iid) { return lpbiref[iid].empty(); }

  int add(int iid, LPBIneq& lpbi);
  int del(int iid);
  void clear();

  // iterate through iids
  int first();
  int next();
  int last();
  
  int Print_One(int i,ostream& out=cout, Atoms* atoms = 0);
  int Print(ostream& out,Atoms* atoms = 0);

private:
  // The index datastructure by iid reference
  RArray<LPBIneq> lpbiref;
  int current_iid;
  int last_iid;
};


inline int LPBIRefs::first() { current_iid = min(); last_iid = max(); return current_iid; }
inline int LPBIRefs::last() { return current_iid > last_iid;}
inline int LPBIRefs::next() 
{ 
  int ret = current_iid++;
  while ((current_iid <= last_iid) && (lpbiref[current_iid].empty()))
    {
      current_iid++;
    }
  return ret;
}

#endif
