#ifndef _LPBIneqSet_h
#define _LPBIneqSet_h

#include "LPBIneq.h"
#include "OrdInt.h"
#include "TPool.h"
#include "RArray.h"
#include "RArrayList.h"

class LPBIneqSet {
public:
  LPBIneqSet();
  ~LPBIneqSet();
  LPBIneqSet(const LPBIneqSet& );
  LPBIneqSet& operator=(const LPBIneqSet& );

  void clear();
  int card();  
  int add(LPBIneq& lpbi);
  void del(int iid);
  LPBIneq get_lpbi(int iid);
  OrdInt get_iids();

  int fixed_literal(); // lit != 0 if one ineq implies fixing of lit

  int simply_implies(LPBIneq& lpbi); // does an ineq in S simply implies lpbi?
  int delete_implied_by(LPBIneq& lpbi); // delete all ineqs implied by lpbi
  int delete_implied(); // deletes all ineqs that are simply implied by another (quadratic)

  // iterate through all LPBIneqs
  void first() { alliids.first(); }
  LPBIneq& next() { return Pool[alliids.next()]; } // don't change it
  int last() { return alliids.last(); }

  OrdInt all_vars();

private:
  int greatest_iid; // the highest inequality identifier
  OrdInt alliids;
  
  // the LPBIneq Pool;
  static TPool<LPBIneq> Pool; 

  friend class Enumerate;
  friend class PBCS;
};

inline OrdInt LPBIneqSet::get_iids()
{
  return alliids;
}

#endif

