#ifndef _PBCSfixing_h
#define _PBCSfixing_h

// fixes the literal lit in the constraint set
int PBCS::fix(int lit);
int PBCS::fix_ref(RArray<LitRef> ref, int lit);

// returns literal != 0 if there is a constraint that implies
// fixing of that literal
int PBCS::fixed_literal();

// fixes all literals that are detected by fixed_literal as long
// as possible and returns all fixed literals
OrdInt PBCS::fixing();

// returns the set of all literals that are fixed by pseudo-Boolean
// unit resolution if literal lit is fixed
OrdInt PBCS::fixed_by(int lit, int& is_unsat);

// returns the set of all literals that yield an unsatisfiable
// problem if they are fixed and pseudo-Boolean unit resolution
// is applied. Additionally, if A->B and ~A -> B, then B can
// also be fixed. 
// Note! The literals are not fixed, just detected.
OrdInt PBCS::fixingcheck();

#endif
