#ifndef PolPBIneq_h
#define PolPBIneq_h

#include "PolPBTerm.h"

class PolPBIneq {
public:
  PolPBIneq();
  PolPBIneq(PolPBIneq&);
  PolPBIneq(PolPBTerm&, Coefficient );
  PolPBIneq& operator=(PolPBIneq& );
  ~PolPBIneq();

  int add(Coefficient coefficient, OrdInt& literals);
  int is_linear();
  int Print(ostream& out=cout, Atoms* atoms=0);

private:
  PolPBTerm t;
  Coefficient rhs;

  int normalize();
  friend ostream& operator<<(ostream& ,PolPBIneq& );
  friend int linearize_fortet(PolPBIneq&, LPBIneqSet&, Atoms* atoms); // as ineq
  friend int lin_addcase(PolPBIneq& pbi, LPBIneqSet& S, Coefficient rhs, int fixlit, PolPBIneq& old);
  friend int linearize(PolPBIneq&, LPBIneqSet&); // must be ineq
  friend int lin_split(PolPBIneq& pbi, int literal, PolPBIneq& pos, PolPBIneq& neg);
  friend Coefficient nl_lowerbound(PolPBTerm& t, LPBIneqSet& S, int fixlit, PolPBIneq& pbi);
};

inline int PolPBIneq::is_linear() { return t.is_linear(); }
inline int PolPBIneq::add(Coefficient coefficient, OrdInt& literals)
{ int ret = t.add(coefficient,literals);  normalize(); return ret; }
inline ostream& operator<<(ostream& out,PolPBIneq& lpbi) 
{ lpbi.Print(out); return out; }

#endif
