#ifndef PolPBTerm_h
#define PolPBTerm_h

#include "OrdInt.h"
#include "PBTerm.h"
#include "LPBIneqSet.h"

class PolPBTermNode;

class PolPBTerm {
public:
  PolPBTerm();
  PolPBTerm(PolPBTerm&);
  PolPBTerm(PBTerm&);
  PolPBTerm& operator=(PBTerm&);
  PolPBTerm& operator=(PolPBTerm&);
  ~PolPBTerm();

  int is_linear();
  int no_products();

  int mul_constant(Coefficient );
  int add(Coefficient coefficient, OrdInt& literals);
  int del(OrdInt& literals); 

  int Print(ostream& out=cout, Atoms* atoms=0);
  
  int initialize(SimpleString& s, Atoms* atoms);

private:
  PolPBTermNode* products;
  Coefficient constant; 

  friend ostream& operator<<(ostream& ,PolPBTerm& );
  friend int linearize_fortet(PolPBTerm&, Products&, LPBIneqSet&, Atoms* ); // linearize a term (objective function)
  friend class PolPBIneq;
  friend int lin_addcase(PolPBIneq& pbi, LPBIneqSet& S, Coefficient rhs, int fixlit, PolPBIneq& old);
  friend int lin_split(PolPBTerm& t, int literal, PolPBTerm& pos, PolPBTerm& neg);
  friend int linearize(PolPBIneq& pbi, LPBIneqSet& S); 
  friend int lin_splitlit(PolPBTerm& pbt);
  friend Coefficient nl_lowerbound(PolPBTerm& t, LPBIneqSet& S, int fixlit, PolPBIneq& pbi);
};

class PolPBTermNode {
private:
  Coefficient coefficient;
  OrdInt literals;
  PolPBTermNode* next;
  friend PolPBTerm;
  friend int linearize_fortet(PolPBTerm&, Products&, LPBIneqSet&, Atoms* ); // linearize a term (objective function)
  friend int lin_split(PolPBTerm& t, int literal, PolPBTerm& pos, PolPBTerm& neg);
  friend int linearize(PolPBIneq& pbi, LPBIneqSet& S); 
  friend int lin_splitlit(PolPBTerm& pbt);
  friend Coefficient nl_lowerbound(PolPBTerm& t, LPBIneqSet& S, int fixlit, PolPBIneq& pbi);
};

inline ostream& operator<<(ostream& out,PolPBTerm& lpbi) 
{ lpbi.Print(out); return out; }

#endif
