// hacking around with template instantiation (I hate C++!)
// i.e. its different compilers; with different templates...
// and its fuzzy compilers....

#define RArray_C
#include "RArray.h"
#include "streaminclude.h"

template <class T> RArray<T>::RArray(int f,int t)
{
  from = f;
  to = t;
  size = to-from+1;
  allocated = new T[size];
  if (allocated == 0)
    {
      cerr << " RArray : RArray : no more memory \n";
      exit(-1);
    }  
  a = allocated - from;
}

template <class T> RArray<T>::~RArray()
{
  delete [] allocated;
}

template <class T> RArray<T>::RArray(const RArray<T>& ra)
{
  from = ra.from;
  to = ra.to;
  size = ra.size;
  
  allocated = new T[size];
  if (allocated == 0)
    {
      cerr << " RArray : RArray : no more memory \n";
      exit(-1);
    }  
  for(int i=0;i<size;i++)
    allocated[i] = ra.allocated[i];  
  a = allocated - from;
}

template <class T> void RArray<T>::operator=(const  RArray<T>& ra)
{
  if (size < ra.size)
    {
      delete [] allocated;
      from = ra.from;
      to = ra.to;
      size = ra.size;
      allocated = new T[size];
      if (allocated == 0)
	{
	  cerr << " RArray : RArray : no more memory \n";
	  exit(-1);
	}  
    }
  for(int i=0;i<size;i++)
    allocated[i] = ra.allocated[i];  
  a = allocated - from;
}

template <class T> void RArray<T>::resize(int f,int t)
{
  if ((f == from) && (t == to))
    return;
  T* hallocated;  
  T* h;
  size = t-f+1;
  hallocated = new T[size];  
  if (hallocated == 0)
    {
      cerr << " RArray : resize : no more memory \n";
      exit(-1);
    }  
  h = hallocated-f;
  for(int i=f;i<=t;i++)
    if ((i >= from) && (i <= to))
      h[i] = a[i];  
  delete [] allocated;
  allocated = hallocated;
  a = h;
  from = f;
  to = t;
}

template <class T> void RArray<T>::init_size(int f,int t)
{
  if ((f == from) && (t == to))
    return;
  from = f;
  to = t;
  size = to-from+1;
  delete [] allocated;
  allocated = new T[size];  
  if (allocated == 0)
    {
      cerr << " RArray : resize : no more memory \n";
      exit(-1);
    }  
  a = allocated-from;
}

template <class T> void RArray<T>::ensure(int index)
{
  if ((from <= index) && (index <= to))
    return;
  if (from > index)
    resize(index,to);
  else // index > to
    resize(from,index);
}

template <class T> void RArray<T>::ensure(int min, int max)
{
  if (min > max)
    return;
  if (min >= from) 
    {
      if (max <= to)
	return;
      else
	ensure(max); // just one side to resize
    }
  if (max <= to)
    {
      ensure(min); // just one side to resize
    }
  // both sides to resize
  resize(min,max);
}

/* gebbts ned
template <class T> void RArray<T>::insert(int i, int last, const T& t)
{ // not that efficient
  if (i > last) 
    {
      if (i >= size)
	enlarge(i+1);
      a[i] = t;
      return;
    }
  if (i >= size)
    {
      enlarge(i+1);
      a[i] = t;
      return;
    }
  if (last >= size)
    {
      enlarge(size+1);
      move(1,i);
      a[i] = t;
      return;
    }
  // i <= last < size 
  if (last == size-1)
      enlarge(size+1);
  for(int j = last;j>=i;j--)
    a[j+1] = a[j];  
  a[i] = t;
}

// moves a[i] -> a[i+offset] for all i+offset < size
template <class T> void RArray<T>::move(int offset,int pos)
{
  for(int i = size-1-offset;i>=pos;i--)
    a[i+offset] = a[i];
}
*/

