#ifndef RArray_h
#define RArray_h

template <class T> class RArray {
public:
  RArray(int from=0,int to=64);
  ~RArray();
  RArray(const RArray&);
  void operator=(const RArray&);

  T& operator[](int i) { return a[i];} // no check but fast!
  void resize(int from, int to);
  void init_size(int from, int to); // do not copy old values
  void ensure(int index);
  void ensure(int min, int max);
  int lower() {return from;}
  int upper() {return to;}
  
private:
  int size;
  int from;
  int to;
  T* a;
  T* allocated;
  void move(int,int);
};

typedef RArray<int> rarrayint;

#ifdef __GNUC__
#ifndef RArray_C
#include "RArray.C"
#endif
#endif


#endif
