// hacking around with template instantiation (I hate C++!)
// i.e. its different compilers; with different templates...
// and its fuzzy compilers....

#define RArrayList_C
#include "RArrayList.h"
#include "streaminclude.h"

template <class T> RArrayList<T>::RArrayList(int s)
{
  size = s+1;
  a = new Node[size];
  if (a == 0)
    {
      cerr << " RArrayList : RArrayList : no more memory \n";
      exit(-1);
    }  
  first_index = 0; // empty
  a[0].next = a[0].prev = 0;
  for (int i=1;i<size;i++)
    {
      a[i].next = a[i].prev = 0;
    }
}

template <class T> RArrayList<T>::~RArrayList()
{
  delete [] a;
}

template <class T> RArrayList<T>::RArrayList(const RArrayList<T>& ra)
{
  size = ra.size;
  a = new Node[size];
  if (a == 0)
    {
      cerr << " RArrayList : RArrayList : no more memory \n";
      exit(-1);
    }  
  for(int i=0;i<size;i++)
    a[i] = ra.a[i];  
  first_index = ra.first_index;
}

template <class T> void RArrayList<T>::operator=(const  RArrayList<T>& ra)
{
  if (size < ra.size)
    {
      delete [] a;
      size = ra.size;
      a = new Node[size];
      if (a == 0)
	{
	  cerr << " RArrayList : RArrayList : no more memory \n";
	  exit(-1);
	}  
    }
  // copy the complete List including inactive elements 
  for(int i=0;i<size;i++)
    a[i] = ra.a[i];  
  first_index = ra.first_index;
}

template <class T> void RArrayList<T>::enlarge(int rs)
{
  rs++; // assure the actual index
  if (rs <= size)
    return;
  Node* h;
  h = new Node[rs];
  if (h == 0)
    {
      cerr << " RArrayList : RArrayList : no more memory \n";
      exit(-1);
    }  
  for(int i=0;i<size;i++)
    h[i] = a[i];  
  delete [] a;
  a = h;
  size = rs;
}

// list functions
template <class T> void RArrayList<T>::make_list(int i,int j)
{
  if (i < 0)
    return;
  first_index = i;
  while (i <= j)
    {
      a[i].prev = i-1;
      a[i].next = i+1;
      i++;
    }
  a[first_index].prev = 0;
  a[j].next = 0;
}

template <class T> void RArrayList<T>::swap(int i,int j)
{
  if (i < 0 || j < 0 || i >= size || j >= size)
    return;
  int n,p;
  n = a[i].next;
  p = a[i].prev;
  a[i].next = a[j].next;
  a[i].prev = a[j].prev;
  a[j].next = n;
  a[j].prev = p;
}

template <class T> void RArrayList<T>::insert_after(int i,int j)
{
  if (i == j)
    { 
      cerr << "RArrayList : insert_after : itself after itself \n";
      exit(-1);
    }
  if (i <= 0 || j <= 0 || i >= size || j >= size)
    {
      cerr << "RArrayList : insert_after : itself after itself \n";
      exit(-1);
    }
  cerr << "RArrayList : insert_after : not yet implemented \n";
  exit(-1);
}

template <class T> void RArrayList<T>::insert_front(int i)
{
  if (active_elem(i))
    {
      cerr << "RArrayList : insert_front : elem already active \n";
      exit(-1);
    }
  a[i].next = first_index;
  a[i].prev = 0;
  a[first_index].prev = i;
  first_index = i;
}


