// hacking around with template instantiation (I hate C++!)
// i.e. its different compilers; with different templates...
// and its fuzzy compilers....

#define SimpleList_C
#include "SimpleList.h"
#include "streaminclude.h"

template <class T> SimpleList<T>::SimpleList()
{
  current = head = new SimpleListNode<T>();
  head->next = head;
  head->prev = head;
}

template <class T> SimpleList<T>::~SimpleList()
{
  current = head->next;
  while (current != head)
    { 
      current = current->next;
      delete current->prev;
    }
  delete head;
}

template <class T> SimpleList<T>::SimpleList(const SimpleList<T>& sl)
{
  SimpleListNode<T>* hptr1;
  SimpleListNode<T>* hptr2 = sl.head;
  SimpleListNode<T>* newnode;

  head = new SimpleListNode<T>();
  head->next = head->prev = head;
  current = head;
  if (hptr2->next == hptr2) // empty list
    return;
  hptr2 = hptr2->next; // the first element of sl
  hptr1 = head;
  while(hptr2 != sl.head) 
    {
      newnode = new SimpleListNode<T>(hptr2->info);
      hptr1->next = newnode;
      newnode->prev = hptr1;
      newnode->next = head;
      head->prev = newnode;
      hptr1 = hptr1->next;
      hptr2 = hptr2->next;
    }
}

template <class T> SimpleList<T>& SimpleList<T>::operator=(const SimpleList<T>& sl)
{
  SimpleListNode<T>* hptr1 = head;
  SimpleListNode<T>* hptr2 = sl.head;
  SimpleListNode<T>* newnode;

  this->clear();
  if (hptr2->next == hptr2) // empty list
    return *this;
  hptr1 = head;
  hptr2 = hptr2->next;
  while(hptr2 != sl.head)
    {
      newnode = new SimpleListNode<T>(hptr2->info);
      hptr1->next = newnode;
      newnode->prev = hptr1;
      newnode->next = head;
      head->prev = newnode;
      hptr1 = hptr1->next;
      hptr2 = hptr2->next;
    }
  return *this;
}

template <class T> int SimpleList<T>::length()
{
  int noelems = 0;
  SimpleListNode<T>* hptr = head->next;
  while(hptr != head)
    {
      noelems++;
      hptr = hptr->next;
    }
  return noelems;
}

template <class T> int SimpleList<T>::empty()
{
  if (head->next == head) 
    return 1;
  else 
    return 0;
}

template <class T> void SimpleList<T>::clear()
{
  current = head->next;
  while (current != head)
    { 
      head->next = current->next;
      current = current->next;
      delete current->prev;
      current->prev = head;
    }
}

template <class T> void SimpleList<T>::push(T& t)
{
  SimpleListNode<T>* newnode = new SimpleListNode<T>(t);

  newnode->next = head->next;
  newnode->prev = head;
  head->next->prev = newnode;
  head->next = newnode;
}

template <class T> T& SimpleList<T>::top()
{
  if (head->next != head)
    return head->next->info;
  else
    {
      cerr << "SimpleList : top : list empty \n";
      return head->info;
    }
}

template <class T> void SimpleList<T>::pop()
{
  if (head->next == head)
    return;
  SimpleListNode<T>* hptr = head->next;
  head->next = hptr->next;
  hptr->next->prev = head;
  delete hptr;  
}

// iteration
template <class T> void SimpleList<T>::first()
{
  current = head->next;
}

template <class T> int SimpleList<T>::is_first()
{  
  if ((current == head->next) && (head->next != head))
    return 1;
  else
    return 0;
}

template <class T> void SimpleList<T>::last()
{
  current = head->prev;
}

template <class T> int SimpleList<T>::is_last()
{  
  if ((current == head->prev) && (head->prev != head))
    return 1;
  else
    return 0;
}

template <class T> T& SimpleList<T>::get_current()
{
  if (current == head)
    {
      cerr << "SimpleList<T> : get_current : invalid current\n";
      exit(-1);
    }
  else
    {
      return current->info;
    }
}

template <class T> int SimpleList<T>::is_valid_current()
{
  if (current == head)
    return 0;
  else
    return 1;
}

template <class T> void SimpleList<T>::forward()
{
  current = current->next; // circular list!
}

template <class T> void SimpleList<T>::backward()
{
  current = current->prev; // circular list!
}

template <class T> void SimpleList<T>::insert_before_current(T& t)
{
  SimpleListNode<T>* newnode = new SimpleListNode<T>(t);

  newnode->prev = current->prev;
  newnode->next = current;
  newnode->prev->next = newnode;
  current->prev = newnode;
}

template <class T> void SimpleList<T>::insert_after_current(T& t)
{
  SimpleListNode<T>* newnode = new SimpleListNode<T>(t);

  newnode->next = current->next;
  newnode->prev = current;
  newnode->next->prev = newnode;
  current->next = newnode;
}

template <class T> void SimpleList<T>::delete_current(int dir)
{
  if (current == head)
    {
      cerr << "SimpleList<T> : delete_current : invalid current\n";
      exit(-1);
    }
  SimpleListNode<T>* hptr = current;
  
  current->prev->next = current->next;
  current->next->prev = current->prev;
  if (dir < 0)
    current = current->prev;
  else if (dir > 0)
    current = current->next;
  else
    current = 0;
  delete hptr;  
}


