// hacking around with template instantiation (I hate C++!)
// i.e. its different compilers; with different templates...
// and its fuzzy compilers....

#define SimpleRBTree_C
#include "SimpleRBTree.h"
#include "streaminclude.h"

template <class Key,class Data> RBTree<Key,Data>::RBTree(const Key& kmin)
{
  bot = new RBNode<Key,Data>();
  bot->left = bot;
  bot->right = bot;
  bot->color = BLACK;
  head = new RBNode<Key,Data>();
  head->key = kmin;
  head->left = bot;
  head->right = bot;
  head->color = BLACK;
}

template <class Key,class Data> void RBTree<Key,Data>::clear()
{
  del_rec(head->right);
  bot->left = bot;
  bot->right = bot;
  bot->color = BLACK;
  head->left = bot;
  head->right = bot;
  head->color = BLACK;
}

template <class Key,class Data> RBTree<Key,Data>::~RBTree()
{
  del_rec(head->right);
  delete head;
  delete bot;
}

template <class Key,class Data> void RBTree<Key,Data>::del_rec(
         RBNode<Key,Data>* x)
{
  if ((x != bot) && (x != head))
    {
      del_rec(x->left);
      del_rec(x->right);
      delete x;
    }
}

template <class Key,class Data> RBTree<Key,Data>::RBTree(RBTree<Key,Data>& )
{
  // TODO
}

template <class Key,class Data> void RBTree<Key,Data>::operator=(RBTree<Key,Data>& rbt)
{
  // TODO
}
 
template <class Key,class Data> void RBTree<Key,Data>::insert(Key& k,Data& d)
{
  RBNode<Key,Data>* x = head;
  RBNode<Key,Data>* p = head;
  RBNode<Key,Data>* g = head;
  RBNode<Key,Data>* gg = 0;

  while(x != bot)
    {
      gg = g; g = p; p = x;
      x = (k < x->key) ? x->left : x->right;
      if ((x->left->color == RED) && (x->right->color == RED))
	split(x,p,g,gg,k);      
    }
  x = new RBNode<Key,Data>(k,d,bot,bot,RED);
  if (k < p->key) 
    p->left = x;
  else
    p->right = x;
  split(x,p,g,gg,k);
  head->right->color = BLACK;
}

template <class Key,class Data> void RBTree<Key,Data>::split(
	RBNode<Key,Data>* x, RBNode<Key,Data>* p, RBNode<Key,Data>* g, RBNode<Key,Data>* gg, 
	Key& k)
{
  x->color = RED;
  x->left->color = BLACK;
  x->right->color = BLACK;
  if (p->color == RED)
    {
      g->color = RED;
      if ((k < g->key) != (k < p->key))
	p = rotate(k,g);
      x = rotate(k,gg);
      x->color = BLACK;
    }
}

template <class Key,class Data> RBNode<Key,Data>* RBTree<Key,Data>::rotate(
        Key& k, RBNode<Key,Data>* y)
{
  RBNode<Key,Data>* c;
  RBNode<Key,Data>* gc;
  c = (k < y->key) ? y->left : y->right;
  if (k < c->key)
    {
      gc = c->left;
      c->left = gc->right;
      gc->right = c;
    }
  else
    {
      gc = c->right;
      c->right = gc->left;
      gc->left = c;
    }
  if (k < y->key)
    y->left = gc;
  else
    y->right = gc;
  return gc;
}

template <class Key,class Data> Data* RBTree<Key,Data>::lookup(Key& k)
{
  RBNode<Key,Data>* x= head->right;
  
  bot->key = k;
  while (k != x->key)
    x = (k < x->key) ? x->left : x->right;
  if (x != bot)
    return &(x->data);
  else
    return 0;
}

template <class Key,class Data> void RBTree<Key,Data>::Print(ostream& out)
{
  Inorder_show(head->right,out,0);
}

template <class Key,class Data> void RBTree<Key,Data>::Inorder_show(
        RBNode<Key,Data>* x,ostream& out,const int depth)
{
  int d = depth;
  if (x != bot)
    {
      while(d--)
	out << " ";
      out << "(" << x->key << "," << x->data << ")\n";
      Inorder_show(x->left,out,depth+1);
      Inorder_show(x->right,out,depth+1);
    }
}
