#ifndef SimpleRBTree_h
#define SimpleRBTree_h

#include "streaminclude.h"

template <class Key,class Data> class RBNode {
public:
  Key key;
  Data data;
  RBNode<Key,Data>* left;
  RBNode<Key,Data>* right;
  int color;

// public:
  RBNode() { left = right = 0; color = 0; }
  RBNode(Key& k, Data& d, RBNode<Key,Data>* ll = 0, RBNode<Key,Data>* rr = 0, int c = 0) 
    : key(k), data(d), left(ll), right(rr), color(c) {}
  ~RBNode() {}
  RBNode(RBNode& rbn) : key(rbn.key), data(rbn.data) { left = right = 0, color = 0; }   
};

template <class Key,class Data> class RBTree {
public:
  RBTree(const Key& ); // the minimal element of class Key
  ~RBTree();
  RBTree(RBTree& );
  void operator=(RBTree& );

  void clear();
  void insert(Key& ,Data& ); // no duplicate keys (overwrites if key exists)
  Data* lookup(Key& ); // nonnull if found

  void Print(ostream& out=cout);
  void Inorder_show(RBNode<Key,Data>* x,ostream& out=cout,const int depth=0);

private:
  RBNode<Key,Data>* head;
  RBNode<Key,Data>* bot;
  enum {RED = 1, BLACK = 0};

  void del_rec(RBNode<Key,Data>* );

  void split(RBNode<Key,Data>*, RBNode<Key,Data>*, RBNode<Key,Data>*, RBNode<Key,Data>*, Key&);
  RBNode<Key,Data>* rotate(Key&, RBNode<Key,Data>*);
};


#ifdef __GNUC__
#ifndef SimpleRBTree_C
#include "SimpleRBTree.C"
#endif
#endif
  
#endif
