#include "SolStack.h"

SolStack::SolStack()
{
  size = 32768;
  clear();
  solution.ensure(size);
}

SolStack::~SolStack()
{
  clear();
}

void SolStack::clear() 
{ 
  _top = -1; 
}

int SolStack::empty() 
{ 
  return (_top == -1); 
}

int SolStack::pop() 
{ 
  if (_top >= 0) 
    return solution[_top--]; 
  else 
    return 0; 
}

int SolStack::top() 
{ 
  return _top; 
}

OrdInt SolStack::to_OrdInt()
{
  OrdInt oi;
  int i;

  for (i=0; i <= _top; i++)
    oi.add(solution[i]);
  return oi;
}

void SolStack::from_OrdInt(OrdInt oi)
{
  clear();
  oi.first();
  while (!oi.last())
    {
      push(oi.next());
    }
}
