// hacking around with template instantiation (I hate C++!)
// i.e. its different compilers; with different templates...
// and its fuzzy compilers....

#define TPool_C
#include "TPool.h"
#include "stdlib.h"

template <class T> TPool<T>::TPool()
{
  if ((the_pool = new T*[MAXBLOCKS]) == 0)
    {
      cerr << "TPool: fatal memory allocation error";
      exit(-1);
    }
  for (int i = 0; i < MAXBLOCKS; i++)
    the_pool[i] = 0;
}

template <class T> TPool<T>::~TPool()
{
  for (int i = 0; i < MAXBLOCKS; i++)
      if (the_pool[i] != 0)
	  delete [] the_pool[i];
  delete [] the_pool;
}


// returns a new clause identifier, 0 if there is none left
template <class T> int TPool<T>::get_new_id()
{
  if (!freeids.empty())
      return freeids.pop();
  // else allocate new block
  int j;
  int i=0;
  while ((i < MAXBLOCKS) && (the_pool[i] != 0))
    i++;
  if (the_pool[i] != 0)
    {
      cerr << "TPool: no more memory";
      return 0;
    }
  else
    {
      if ((the_pool[i] = new T[BLOCKSIZE]) == 0)
	{
	  cerr << "TPool: memory allocation error";
	  exit(-1);
	}
      // else
      // assure that small iids become allocated first
      for (j=BLOCKSIZE-1; j >= 0; j--)               // give the new blocks free 
	{
	  freeids.unordered_push(i*BLOCKSIZE + (j+1)); // (unordered)
	}
      return freeids.pop();
    }  
}

// gives the clause with clause identifier id back to the pool
template <class T> int TPool<T>::free_id(int id)
{
  freeids.unordered_push(id); // not ordered
  return 0;
}

/* moved inline
// reference to the extended clause by id
template <class T> T& TPool<T>::get_elem(int id)
{
//  cout << "freeids " << freeids << "\n";
//  cout << id << ":" << (id-1)/BLOCKSIZE << " " << (id-1)%BLOCKSIZE << "\n";
  return *(the_pool[(id-1)/BLOCKSIZE]+((id-1)%BLOCKSIZE));
}

*/
