#ifndef TPool_h
#define TPool_h

#include "OrdInt.h"

template <class T> class TPool {
public:
  TPool();
  ~TPool();
  TPool(TPool& ) { cerr << "DON'T COPY CONSTRUCT TPOOL"; }
  int get_new_id();      // returns a new identifier, 0 if there is none left
  int free_id(int id);  // gives the element with identifier id back to the pool
  T& get_elem(int id)   // reference to the element by cid
  { return *(the_pool[(id-1)/BLOCKSIZE]+((id-1)%BLOCKSIZE)); }
  T& operator[](int id) { return get_elem(id); }
private:
  OrdInt freeids; // which clause identifiers can be used (note that not necessarily ordered)
  enum {BLOCKSIZE = 1024};
//  enum {BLOCKSIZE = 6};
  enum {MAXBLOCKS = 1024};
  // the maximal number of elements is BLOCKSIZE*MAXBLOCKS
  T** the_pool;
};

#ifdef __GNUC__
#ifndef TPool_C
#include "TPool.C"
#endif
#endif

#endif
