// the help texts for interactive mode

#include "PBCS.h"

extern SimpleString command;
extern SimpleString arguments[100];

void com_help_history()
{
  cout << "  h | history n : shows the last n commands (1 <= n <= 100) \n";
  cout << "                  Redo nth command by typing n \n";
}

void com_help_clear()
{
  cout << "  clear : clears workspace \n";
  cout << "          deletes all constraints and objective function \n";
}

void com_help_read()
{
  cout << "  read file : reads problem in opbdp-format from file \n";
}

void com_help_readnlf()
{
  cout << "  read file : reads nonlinear problem. Linearizing with Fortet's method.\n";
}

void com_help_readnlp()
{
  cout << "  read file : reads nonlinear problem. Linearizing with my method.\n";
}

void com_help_write()
{
  cout << "  write solver file : writes current problem to file for solver \n";
  cout << "                      solver can be either cplex, lpsolve or opbdp \n";
}

void com_help_show()
{
  cout << "  show : information about the current problem \n";
  cout << "      show ineqs    : displays all inequalities with their iids \n";
  cout << "      show ineq iid : displays the inequality with identifier iid \n";
  cout << "      show objf     : displays objective function \n";
  cout << "      show all      : displays all inequalities and objective function \n";
  cout << "      show size     : displays size of the current problem \n";
  cout << "      show lastsolution  : displays the last solution (if one) encountered \n";
  cout << "                           while handling the problem \n";
  cout << "                           Also the value of the objective function is displayed \n";
}

void com_help_del()
{
  cout << "  del iid : deletes the inequality with identifier iid \n";
}

void com_help_add()
{
  cout << "  add c : adds the linear pseudo-Boolean constraint c \n";
}

void com_help_min()
{
  cout << "  min t : sets the objective function to the linear pseudo-Boolean term t \n";
  cout << "          with the goal to minimize the value of t \n";
}

void com_help_max()
{
  cout << "  min t : sets the objective function to the linear pseudo-Boolean term t \n";
  cout << "          with the goal to maximize the value of t \n";
}

void com_help_singlevars()
{
  cout << "  singlevars : computes the set of all literals whose negation does \n";
  cout << "               not occur in the constraint set \n";
}

void com_help_fix()
{
  cout << "  fix l : add the constraints l = 1 and applies fixing \n";
}

void com_help_fixing()
{
  cout << "  fixing : incompletely checks whether Li = 1 holds for some Li \n";
  cout << "           If yes these literals are fixed and eliminated from the problem \n";
}

void com_help_fixingcheck()
{
  cout << "  fixingcheck : see fixing \n";
  cout << "                More effort; temporary fixings (see fixinglit) \n";
}

void com_help_equate()
{
  cout << "  equate l k : adds the constraint l = k \n";
}

void com_help_eqcheck()
{
  cout << "  eqcheck : incompletely checks whether equations of the form Li = Lj hold \n";
  cout << "            If yes these are computed and one of the literals is eliminated \n";
}

void com_help_gencover()
{
  cout << "  gencover : generates a cover \n";
  cout << "             A cover is an inequality of the form L1 + ... + Ln >= 1 \n";
  cout << "             such that fixing L1 = ... = Ln = 0 together with all other constraints \n";
  cout << "             is unsatisfiable via pseudo-Boolean unit resolution \n";
}

void com_help_genmincover()
{
  cout << "  genmincover : generates a better cover \n";
  cout << "                see gencover \n";
  cout << "                Additionally, some literals are tried to eliminate, thus \n";
  cout << "                strengthening the cover \n";
}

void com_help_addcover()
{
  cout << " addcover : generates and add cover (see gencover) \n";
}

void com_help_addmincover()
{
  cout << " addmincover : generates and add mincover (see genmincover) \n";
}

void com_help_addcovers()
{
  cout << " addcovers n : generates and adds n mincovers (see genmincover) \n";  
  cout << "               n defaults to 20 \n";
}

void com_help_lowerbound()
{
  cout << " lowerbound t : computes a lowerbound of the pseudo-Boolean term t\n";  
}

void com_help_coeffred()
{
  cout << "  coeffred : reduces coefficients with help of a bounding procedure \n";
}

void com_help_coeffredM()
{
  cout << "  coeffredM : see coeffred \n";
  cout << "              just large coefficients wrt. the right-hand side are tried \n";
}

void com_help_fixinglit()
{
  cout << "  fixinglit l : Temporarily fixes the literal l and shows all \n";
  cout << "                immediate (pseudo-Boolean unit resolution) consequences \n";
  cout << "                After execution l remains unfixed! (what if) \n";
}

void com_help_delimp()
{
  cout << "  delimp : deletes inequalities that are trivially implied by other inequalities \n";
  cout << "           useful as simple preprocessing and after adding logic cuts \n";
}

void com_help_solve()
{
  cout << "  solve n : solves 0-1 problem by pure enumeration \n";
  cout << "            just feasible solution is computed \n";
  cout << "            if n is given at most n nodes are explored \n";
}

void com_help_coversolve()
{
  cout << "  coversolve : solves 0-1 problem by pure logic cut generation \n";
  cout << "               just feasible solution is computed \n";
  cout << "  NOTE!! Problem is changed, sincee cuts are added \n";
}

void com_help_opt()
{
  cout << "  opt : solves 0-1 optimization problem by pure enumeration \n";
}

void com_help_coveropt()
{
  cout << "  coveropt : solves 0-1 optimization problem by pure logic cut generation \n";
  cout << "    coversolve until a) problem is unsatisfiable -> last solution was optimal \n";
  cout << "    b) a solution is found giving value s to objective function -> lowerbound \n";
  cout << "    s+1 is established and continued\n";
  cout << "  NOTE!!! Original problem is copied and restored after optimization\n";
}

void com_help_set()
{
  cout << "  set  :     option setting \n";
  cout << "    set : shows current setting \n";
  cout << "    set heuristic n : variable selection heuristics while enumerating \n";
  cout << "        n=0: no heuristics at all; first unfixed literal positive  \n";
  cout << "        n=1: adapted two-sided Jeroslow-Wang heuristics <default>  \n";
  cout << "        n=2: similar to h1; probably not exceeding double range  \n";
  cout << "        n=3: fixing a literal yields maximal further fixings in the next step \n";
  cout << "        n=4: randomly selects a literal (rand) \n";
  cout << "        n=1x:  min(H[Li],H[-Li]) is maximal for x  \n";
  cout << "               (1-3: H[Li] + H[-Li] is maximal) \n";
  cout << "        n=1xx: literal with greatest coefficient in objective. function;  \n";
  cout << "               xx if none left \n";
  cout << "    set enumverbosity n : set verbosity level while enumerating \n";
  cout << "        n=0: show nothing; return value is optimum \n";
  cout << "        n=1: show optimal value + init-information \n";
  cout << "        n=3: show each local optima <default> \n";
  cout << "        n=4: a short notice all 500000 nodes \n";
  cout << "    set verbosity n : set general verbosity level while solving \n";
  cout << "    set maxcutnodes n : set maximal number of nodes allowed when searching for a cut\n";
  cout << "                        the higher the more effort is spent for cut generation \n";
  cout << "                        the higher the probability to obtain a better cut \n";
  cout << "    set dellitheu n    : heuristic which literal to eliminate while strengthening cover\n";
  cout << "         n=0 : literal with smallest index (no heuristics) \n";
  cout << "         n=1 : literal that has been selected earliest while enumerating \n";
  cout << "         n=2 : literal that has been selected latest while enumerating \n";
  cout << "         n=4 : random literal \n";
  cout << "    set lowerbound b : adds constraint objective function >= b \n";
  cout << "    set upperbound b : adds constraint objective function <= b \n";
}

void com_help_check()
{
  cout << "  check :     checks whether internal data structure is corrupted\n";
}



void com_help()
{
  if (arguments[0].length() == 0)
    {
      cout << "Available commands : \n";
      cout << "  h | history shows history of commands \n";
      cout << "  clear       clears the workspace \n";
      cout << "  read        reads a 0-1 problem from file \n";
      cout << "  readnlf     reads a nonlinear 0-1 problem (Fortet-linearization)\n";
      cout << "  readnlp     reads a nonlinear 0-1 problem (My-linearization)\n";
      cout << "  write       writes current 0-1 problem to a file \n";
      cout << "  show        display (parts of) the current problem \n";
      cout << "  del         deletes an inequality \n";
      cout << "  add         adds a constraint \n";
      cout << "  min | max   sets the objective function \n";
      cout << "  singlevars  shows variables that occur only positive or negative \n";
      cout << "  fix         fixes a literal to 1 \n";
      cout << "  fixing      tries to detect literals that have to be 1 \n";
      cout << "  fixingcheck tries harder... \n";
      cout << "  equate      equates two literals \n";
      cout << "  eqcheck     tries to detect equations between literals \n";
      cout << "  gencover    generates a cover inequality \n";
      cout << "  genmincover generates a better cover inequality \n";
      cout << "  addcover    generates and adds a cover inequality \n";
      cout << "  addmincover generates and adds a better cover inequality \n";
      cout << "  addcovers   generates and adds cover inequalities \n";
      cout << "  lowerbound  computes lowerbound a linear 0-1 term \n";
      cout << "  coeffred    coefficient reduction \n";
      cout << "  coeffredM   coefficient reduction only for large coefficients \n";
      cout << "  fixinglit   temporarily fixes a literal and displays consequences \n";
      cout << "  delimp      deletes trivially implied inequalities \n";
      cout << "  solve       finds feasible solution (if one) by enumeration \n";
      cout << "  coversolve  finds feasible solution (if one) by pure logic cut generation \n";
      cout << "  opt         finds optimal solution (if one) by enumeration \n";
      cout << "  coveropt    finds optimal solution (if one) by pure logic cut generation \n";
      cout << "  set         options settings \n";
      cout << "  check       verifies internal data structure \n";
      cout << "Type help <command> for further help \n";
      return;
    }
  else if (arguments[0] == "h") com_help_history();
  else if (arguments[0] == "history") com_help_history();
  else if (arguments[0] == "clear") com_help_clear();
  else if (arguments[0] == "read") com_help_read();
  else if (arguments[0] == "write") com_help_write();
  else if (arguments[0] == "show") com_help_show();
  else if (arguments[0] == "del") com_help_del();
  else if (arguments[0] == "add") com_help_add();
  else if (arguments[0] == "min") com_help_min();
  else if (arguments[0] == "max") com_help_max();
  else if (arguments[0] == "singlevars") com_help_singlevars();
  else if (arguments[0] == "fix") com_help_fix();
  else if (arguments[0] == "fixing") com_help_fixing();
  else if (arguments[0] == "fixingcheck") com_help_fixingcheck();
  else if (arguments[0] == "equate") com_help_equate();
  else if (arguments[0] == "eqcheck") com_help_eqcheck();
  else if (arguments[0] == "gencover") com_help_gencover();
  else if (arguments[0] == "genmincover") com_help_genmincover();
  else if (arguments[0] == "addcover") com_help_addcover();
  else if (arguments[0] == "addmincover") com_help_addmincover();
  else if (arguments[0] == "lowerbound") com_help_lowerbound();
  else if (arguments[0] == "coeffred") com_help_coeffred();
  else if (arguments[0] == "coeffredM") com_help_coeffredM();
  else if (arguments[0] == "fixinglit") com_help_fixinglit();
  else if (arguments[0] == "delimp") com_help_delimp();
  else if (arguments[0] == "solve") com_help_solve();
  else if (arguments[0] == "coversolve") com_help_coversolve();
  else if (arguments[0] == "opt") com_help_opt();
  else if (arguments[0] == "coveropt") com_help_coveropt();
  else if (arguments[0] == "set") com_help_set();
  else if (arguments[0] == "check") com_help_check();
  else
    cout << "Command " << arguments[0] << " does not exist. Type help for a list of commands. \n";
}
