#include "timing.h"
#include <stream.h>
#include <math.h>
extern "C" {
#include <stdlib.h>
}

#ifdef WIN32
extern "C" {
int gmt_secs()
{
  struct tm *tp;
  time_t tim;
  time(&tim);
  tp = localtime(&tim);
  return tp->tm_sec;
}
float used_time()
{ 
  return  float(clock())/CLK_TCK;
}
}
#else
float used_time()
{ 
  tms x;
  times(&x);
  return  float(x.tms_utime)/HZ;
}

extern "C" {
int gmt_secs()
{
  struct timeval tp;
  struct timezone tzp;
  gettimeofday(&tp, &tzp);
  return tp.tv_sec;
}
}
#endif


int double_show_fixed(double d,int length)
{
  d *= 100.0; // accurracy two
  int cs = (int ) floor(d);
  int_show_fixed(cs/100,length-3);
  if (cs%100 == 0)
    cout << ".00";
  else if (cs%100 <= 9)
    cout << ".0" << cs%100;
  else
    cout << "." << cs%100;
  return 0;
}

int int_show_fixed(int i,int length)
{
  int j=abs(i);
  int len = 0;
  while ((j = j / 10) > 0)
    len++;
  if (i < 0)
    len++;
  while(length-len > 0)
    {
      length--;
      cout << " ";
    }
  cout << i;
  return 0;
}

