#ifndef timing_h
#define timing_h

#ifdef __lucid_Solaris
// there is an awfull bug in the lucid headers for solaris
// I just include the necessary definitions
extern "C" {
typedef long            clock_t; /* relative time in a specified resolution */
struct tms {
        clock_t tms_utime;              /* user time */
        clock_t tms_stime;              /* system time */
        clock_t tms_cutime;             /* user time, children */
        clock_t tms_cstime;             /* system time, children */
};
clock_t times(struct tms *);
#define       _SC_CLK_TCK     3
extern long _sysconf(int);      /* System Private interface to sysconf() */
#define HZ              ((int)_sysconf(_SC_CLK_TCK))
struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
};

struct timezone {
        int     tz_minuteswest; /* minutes west of Greenwich */
        int     tz_dsttime;     /* type of dst correction */
};
extern int gettimeofday(struct timeval*, struct timezone* );
extern int settimeofday(const struct timeval*);
int gmt_secs();
}
#else
#ifdef WIN32
extern "C" {
#include <time.h>
}
#else 
extern "C" {
#include <unistd.h>
#include <sys/param.h>
#include <sys/times.h>
#include <sys/time.h>
int gmt_secs();
}
#endif
#endif

float used_time();
int double_show_fixed(double d,int length);
int int_show_fixed(int i,int length);



#endif

